;
; A231216 Demo: Blink Test (Arduino style)
;   
#include "p16F648A.inc"

; PIC16F648A Configuration Bit Settings
; __config 0xFF70
    
 __CONFIG _FOSC_INTOSCIO & _WDTE_OFF & _PWRTE_ON & _MCLRE_ON & _BOREN_ON & _LVP_OFF & _CPD_OFF & _CP_OFF

        UDATA
d1      res 1                   ; delay loop counters
d2      res 1 
d3      res 1  
      
RES_VECT  CODE    0x0000        ; processor reset vector
    GOTO    START               ; go to beginning of program

MAIN_PROG CODE                  ; let linker place main program

START
    movlw   b'11111110'		; configure RA0 as output, others as input
    tris    PORTA
    bcf     PORTA,RA0		; RA0 = LED = ON (active LOW)
       
Loop    
    ; delay 0.4s
    movlw	0x36		; initialize delay counters (0.4s)
    movwf	d1
    movlw	0xE0
    movwf	d2
    movlw	0x01
    movwf	d3
Delay_1
    decfsz	d1, f
    goto	$+2
    decfsz	d2, f
    goto	$+2
    decfsz	d3, f
    goto	Delay_1
    
    bsf		PORTA,RA0	; RA0 = LED = OFF (active HIGH)
    
    ; delay 0.4s
    movlw	0x36		; initialize delay counters (0.4s)
    movwf	d1
    movlw	0xE0
    movwf	d2
    movlw	0x01
    movwf	d3
Delay_2
    decfsz	d1, f
    goto	$+2
    decfsz	d2, f
    goto	$+2
    decfsz	d3, f
    goto	Delay_2
    
    bcf		PORTA,RA0	; RA0 = LED = ON (active LOW)
    goto	Loop            ; loop forever

    END